var fs   = require('fs');
var path = require('path');

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Initialize codes.
AutoLoadPlugins();

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//You can load the plugins in global field, if the next line codes are uncommented.
//AutoLoadGlobalPlugins();

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Sample codes.
exports.Test = function()
{
    console.log("Hi, I'm a model test funciton");
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Put you codes here



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// AutoLoadPlugins Function Implement Start.

function AutoLoadPlugins()
{
    var plugin_dir = (__dirname + '/../addon/');
    if(!fs.existsSync(plugin_dir))
    {
        return;
    }
    
    var files = fs.readdirSync(plugin_dir);
    files.forEach(function(filename){
        var filedir = path.join(plugin_dir, filename);
        var stats = fs.statSync(filedir);
        if(!stats.isDirectory())
        {
            if(filedir.indexOf('-linux.node') !== -1 && require('os').platform() === 'linux')
            {
                require(filedir);
            }
            
            if(filedir.indexOf('-win.node') !== -1 && require('os').platform() === 'win32')
            {
                require(filedir);
            }
        }
    });
}

function AutoLoadGlobalPlugins() {
        var plugin_dir = (process.env['COMX_SDK'] + 'addon/');
        if (!fs.existsSync(plugin_dir)) {
                return;
        }

        var files = fs.readdirSync(plugin_dir);
        files.forEach(function(filename) {
                var filedir = path.join(plugin_dir, filename);
                var stats = fs.statSync(filedir);
                if (!stats.isDirectory()) {
                        if (filedir.indexOf('-linux.node') !== -1 && require('os').platform() === 'linux') {
                                require(filedir);
                        }

                        if (filedir.indexOf('-win.node') !== -1 && require('os').platform() === 'win32') {
                                require(filedir);
                        }
                }
        });
}

//AutoLoadPlugins Function Implement End.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ide_info Function Implement Start.

exports.ide_info = (msg) => {
        if (process.send) {
                process.send({
                        type: 'debug',
                        info: msg
                });
        }
}

//ide_info Function Implement End.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
